# 32/64bit spec-file
#
%define octave_api api-v50+
%define _disable_ld_no_undefined 1

Name:           octave
Version:        4.2.1
Release:        %mkrel 4
Summary:        High-level language for numerical computations
License:        GPLv3+
Group:          Sciences/Mathematics
Source0:        ftp://ftp.gnu.org/gnu/octave/%{name}-%{version}.tar.lz
Source4:        octave-2.1.36-emac.lisp
URL:            http://www.gnu.org/software/octave/
Obsoletes:      octave3 < %{version}-%{release}
Provides:       octave3 = %{version}-%{release}
Provides:       octave(api) = %{octave_api}
Requires:       gnuplot
Requires:       GraphicsMagick
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils
Requires(post):   rpm-helper
Requires(post):   info-install
Requires(preun):  info-install
BuildRequires:  bison
BuildRequires:  blas-devel
BuildRequires:  dejagnu
BuildRequires:  desktop-file-utils
BuildRequires:  emacs
BuildRequires:  emacs-nox
BuildRequires:  fftw-devel
BuildRequires:  flex
BuildRequires:  gcc-gfortran
BuildRequires:  gnuplot
BuildRequires:  gperf
BuildRequires:  hdf5-devel
BuildRequires:  lapack-devel
BuildRequires:  ncurses-devel
BuildRequires:  readline-devel
BuildRequires:  texinfo
BuildRequires:  tetex-dvips
BuildRequires:  tetex-latex
BuildRequires: 	pcre-devel
BuildRequires:	curl-devel
BuildRequires:  umfpack-devel
BuildRequires:	%{_lib}glpk-devel
BuildRequires:  %{_lib}amd-devel
BuildRequires:  %{_lib}camd-devel
BuildRequires:  %{_lib}ccolamd-devel
BuildRequires:  %{_lib}cholmod-devel
BuildRequires:  %{_lib}colamd-devel
BuildRequires:  %{_lib}cxsparse-devel
BuildRequires:	%{_lib}qhull-devel
BuildRequires:	%{_lib}qrupdate-devel
BuildRequires:  %{_lib}fltk-devel
BuildRequires:	GraphicsMagick-devel
BuildRequires:	mesagl-devel, mesaglu-devel
BuildRequires:	gl2ps-devel
BuildRequires:	arpack-devel
BuildRequires:	qscintilla-qt4-devel

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Obsoletes:	liboctave1 < %version
Provides:	liboctave1 = %version-%release
Obsoletes: 	%{name} < %version

%description
GNU Octave is a high-level language, primarily intended for numerical
computations. It provides a convenient command line interface for
solving linear and nonlinear problems numerically, and for performing
other numerical experiments using a language that is mostly compatible
with Matlab. It may also be used as a batch-oriented language.

Octave has extensive tools for solving common numerical linear algebra
problems, finding the roots of nonlinear equations, integrating
ordinary functions, manipulating polynomials, and integrating ordinary
differential and differential-algebraic equations. It is easily
extensible and customizable via user-defined functions written in
Octave's own language, or using dynamically loaded modules written in
C++, C, Fortran, or other languages.

%package devel
Summary:        Development headers and files for Octave
Group:          Development/Libraries
Obsoletes:      octave3-devel < %{version}-%{release}
Provides:       octave3-devel = %{version}-%{release}
Obsoletes:		liboctave1-devel < %{version}
Provides:		liboctave1-devel = %{version}-%{release}
Requires:       %{name} = %{version}-%{release}
Requires:       blas-devel
Requires:       fftw-devel
Requires:       gcc-c++
Requires:       gcc-gfortran
Requires:       hdf5-devel
Requires:       lapack-devel
Requires:       readline-devel
Requires:       zlib-devel

%description devel
The octave-devel package contains files needed for developing
applications which use GNU Octave.

%package doc
Summary:        Documentation for Octave, a numerical computational language
Group:          Documentation
Requires(post): info-install
Requires(preun): info-install

%description doc
GNU Octave is a high-level language, primarily intended for numerical
computations. It provides a convenient command line interface for
solving linear and nonlinear problems numerically, and for performing
other numerical experiments using a language that is mostly compatible
with Matlab. It may also be used as a batch-oriented language.

This package contains documentation of Octave in various formats.

%prep
%setup -q

%{__cp} -a %{SOURCE4} octave.el

%build
%define enable64 no
export CPPFLAGS="%{optflags} -DH5_USE_16_API"
export GNUPLOT=%{_bindir}/gnuplot-nox
%{configure2_5x} --enable-dl \
                 --enable-shared \
                 --disable-static \
                 --enable-64=%{enable64} \
                 --with-amd="-lamd -lsuitesparseconfig" \
                 --with-camd="-lcamd -lsuitesparseconfig" \
                 --with-colamd="-lcolamd -lsuitesparseconfig" \
                 --with-ccolamd="-lccolamd -lsuitesparseconfig"

%{make} OCTAVE_RELEASE="%{distribution} %{version}-%{release}" LDFLAGS="-lgfortran -llapack -lGL -lGLU -lpthread"

# emacs mode
%{_bindir}/emacs -batch -q -no-site-file -f batch-byte-compile %{name}.el


%install
%{__rm} -rf %{buildroot}
%{makeinstall_std}

# Make library links
%{__mkdir_p} %{buildroot}/etc/ld.so.conf.d
/bin/echo "%{_libdir}/octave-%{version}" > %{buildroot}/etc/ld.so.conf.d/octave-%{_arch}.conf

# Remove RPM_BUILD_ROOT from ls-R files
%{__perl} -pi -e "s,%{buildroot},," %{buildroot}%{_libexecdir}/octave/ls-R
%{__perl} -pi -e "s,%{buildroot},," %{buildroot}%{_datadir}/octave/ls-R

%{_bindir}/find %{buildroot} -name "*.oct" -print0 | %{_bindir}/xargs -t -0 -r strip --strip-unneeded

%{__mkdir_p} %{buildroot}%{_sysconfdir}/emacs/site-start.d
%{__cp} -a %{name}.elc %{buildroot}%{_sysconfdir}/emacs/site-start.d/%{name}.elc
%{__cp} -a %{name}.el %{buildroot}%{_sysconfdir}/emacs/site-start.d/%{name}.el

# Create desktop file
desktop-file-install --vendor="" \
    --add-category "X-MandrivaLinux-MoreApplications-Sciences-Mathematics" \
    --dir $RPM_BUILD_ROOT%{_datadir}/applications $RPM_BUILD_ROOT%{_datadir}/applications/*

# Create directories for add-on packages
HOST_TYPE=`%{buildroot}%{_bindir}/octave-config -p CANONICAL_HOST_TYPE`
%{__mkdir_p} %{buildroot}%{_libexecdir}/octave/site/oct/%{octave_api}/$HOST_TYPE
%{__mkdir_p} %{buildroot}%{_libexecdir}/octave/site/oct/$HOST_TYPE
%{__mkdir_p} %{buildroot}%{_datadir}/octave/packages
/bin/touch %{buildroot}%{_datadir}/octave/octave_packages

%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/config.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/Array.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/defaults.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/dim-vector.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/idx-vector.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/lo-error.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/lo-mappers.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/lo-math.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/lo-traits.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/lo-utils.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/oct-alloc.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/oct-cmplx.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/oct-inttypes-fwd.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/octave-config.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/lo-ieee.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/oct-inttypes.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/oct-sort.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/pathsearch.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/quit.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/str-vec.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/lo-cutils.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/lo-macros.h
%multiarch_includes %{buildroot}%{_includedir}/octave-%{version}/octave/oct-refcount.h

%clean
%{__rm} -rf %{buildroot}

%post
%_install_info octave.info
%create_ghostfile %{_datadir}/octave/octave_packages root root 0664

%preun
%_remove_install_info octave.info


%post doc
%_install_info liboctave.info
%_install_info Octave-FAQ.info

%preun doc
%_remove_install_info liboctave.info
%_remove_install_info Octave-FAQ.info

%files
%defattr(0644,root,root,0755)
%doc README ChangeLog AUTHORS BUGS 
%doc examples/
%defattr(-,root,root,0755)
%{_bindir}/octave*
%config(noreplace) /etc/ld.so.conf.d/*
%{_libdir}/octave*
%{_datadir}/octave
%{_iconsdir}/*/*/apps/%{name}.png
%{_iconsdir}/*/*/apps/%{name}.svg
%exclude %{_datadir}/octave/octave_packages
%ghost %{_datadir}/octave/octave_packages
%if "%{_libdir}" != "%{_libexecdir}"
%{_libexecdir}/octave
%endif
%{_mandir}/man*/octave*
%{_infodir}/octave.info*
%{_datadir}/applications/*
%config(noreplace) %_sysconfdir/emacs/site-start.d/octave.el*
%{_datadir}/appdata/www.octave.org-octave.appdata.xml

%files devel
%defattr(0644,root,root,0755)
%defattr(-,root,root)
%{_bindir}/mkoctfile*
%{_includedir}/octave-%{version}
%dir %{multiarch_includedir}/octave-*
%multiarch %{multiarch_includedir}/octave-*/octave/config.h
%multiarch %{multiarch_includedir}/octave-*/octave/Array.h
%multiarch %{multiarch_includedir}/octave-*/octave/defaults.h
%multiarch %{multiarch_includedir}/octave-*/octave/dim-vector.h
%multiarch %{multiarch_includedir}/octave-*/octave/idx-vector.h
%multiarch %{multiarch_includedir}/octave-*/octave/lo-error.h
%multiarch %{multiarch_includedir}/octave-*/octave/lo-mappers.h
%multiarch %{multiarch_includedir}/octave-*/octave/lo-math.h
%multiarch %{multiarch_includedir}/octave-*/octave/lo-traits.h
%multiarch %{multiarch_includedir}/octave-*/octave/lo-utils.h
%multiarch %{multiarch_includedir}/octave-*/octave/oct-alloc.h
%multiarch %{multiarch_includedir}/octave-*/octave/oct-cmplx.h
%multiarch %{multiarch_includedir}/octave-*/octave/octave-config.h
%multiarch %{multiarch_includedir}/octave-*/octave/lo-ieee.h
%multiarch %{multiarch_includedir}/octave-*/octave/oct-inttypes.h
%multiarch %{multiarch_includedir}/octave-*/octave/oct-inttypes-fwd.h
%multiarch %{multiarch_includedir}/octave-*/octave/oct-sort.h
%multiarch %{multiarch_includedir}/octave-*/octave/pathsearch.h
%multiarch %{multiarch_includedir}/octave-*/octave/quit.h
%multiarch %{multiarch_includedir}/octave-*/octave/str-vec.h
%multiarch %{multiarch_includedir}/octave-*/octave/lo-cutils.h
%multiarch %{multiarch_includedir}/octave-*/octave/lo-macros.h
%multiarch %{multiarch_includedir}/octave-*/octave/oct-refcount.h


%{_mandir}/man*/mkoctfile*

%files doc
%defattr(0644,root,root,0755)
%doc doc/liboctave/liboctave.html doc/liboctave/liboctave.pdf
%doc doc/refcard/*.pdf
%{_infodir}/liboctave.info.*


%changelog
* Mon Nov 06 2017 bb2 <bb2> - 4.2.1-4pclos2017
- rebuild against updates

* Tue Oct 17 2017 bb2 <bb2> - 4.2.1-3pclos2017
- try to fix build

* Tue Sep 12 2017 bb2 <bb2> - 4.2.1-2pclos2017
- rebuild against updates

* Sun Sep 10 2017 bb2 <bb2> - 4.2.1-1pclos2017
- new version

* Sat Apr 16 2016 bb <bb> - 4.0.1-1pclos2016
- update

* Fri Apr 15 2016 bb <bb> 4.0.0-2pclos2016
- rebuild for updated libs

* Sat Jun 06 2015 gseaman <galen.seaman at comcast.net> 4.0.0-1gseaman2015
- 4.0.0

